# arch-tag: david@allouche.net - 2003-11-24 15:35:19 050584000
# Copyright (C) 2003 David Allouche <david@allouche.net>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""(the docstring for this module is overriden by _import_builtin)"""

__all__ = [
    'errors',
    'pathname',
    'backends',
    'tests'
    # Deprecated modules
    'arch', 'util',
    ]

from _output import *
from _builtin import *
from _escaping import *

def _import_builtin():
    # Along with the monkey-patch in mypydoc, this causes Epydoc to
    # document the public interface as part of the arch package
    # instead of the arch._builtin module (where it is actually
    # defined). This is provides no useful runtime functionality, and
    # is purely needed for documentation purposes.
    import _builtin
    import _output
    import _escaping
    global __doc__
    __doc__ = _builtin._package_doc
    all = _builtin.__all__
    all += _output.__all__
    all += _escaping.__all__
    for name in all:
        getattr(_builtin, name).__module__ = __name__
    __all__.extend(all)
    del _builtin._package_doc
    del _builtin.public

_import_builtin()
# Since this function is only useful for documentation, delete it so
# Epydoc will not show it in the private listing. There is really
# little point in documenting documentation-related stuff...
del _import_builtin

# Deprecated public stuff from before we used __all__.
from errors import ExecProblem
__all__.extend(('ExecProblem'))
from pathname import PathName, FileName, DirName
__all__.extend(('PathName', 'FileName', 'DirName'))
